package form.comp;

import form.io.*;
import form.*;
import java.awt.*;
import java.io.*;

public class FormPanel extends java.awt.Panel implements Serializable {

    private Font font = null;
    private FormInterface current = null;

	//the listener for the selected object
	private FormInterfaceListener selected = null;

    public void setCurrent(FormInterface curr){
	if (current != null) current.getComponent().doLayout();
	current = curr;
	if (current != null) current.getComponent().doLayout();
	doLayout();
    }

    public void save(ToHtml save,String name){
	save.add(name,"form.comp.FormPanel");
	save.add(name+".",getName());
	Component[] all = getComponents();
	for (int i =0; i < all.length; i++){
	   if ( !all[i].getClass().getName().equals("form.comp.PasswordPanel"))
	      ((FormInterface)all[i]).save(save,name+"."+i+".");
	}
    }

    public void redo(){
	Component[] all = getComponents();
	FormInterface temp = null;
        for (int i = 0; i < all.length; i++){ 
	   temp = ((FormInterface)all[i]);
	   remove(temp.getComponent());
	   addImpl(temp.getComponent(),temp.getGridBagConstraints(),i);
        }
	doLayout();
    }

    public void reFresh(){
	Component[] all = getComponents();
        for (int i = 0; i < all.length; i++){ 
	   all[i].doLayout();
        }
	doLayout();
    }

    /**
    * Moves a component within a form
    * @param FormInterface src The Object to be moved
    * @param Point dest The desired location
    * the src object will be placed before the dest object in the form.
    */
    public void moveComp(FormInterface src, Point dest){
	//the index the component will be moved to
	int index =0;
	//Component temp = src.getComponent().getComponentAt(dest);
	//may have to check if in panel
	if (src == current)
	   return;
	if (current == null) {
	   index = getComponentCount();
	}
	else {
	   index = getIndex(current.getComponent()) ;
	}
	remove(src.getComponent());
	addImpl(src.getComponent(),src.getGridBagConstraints(),index);
	validate();
    }

    public FormPanel (){
      super(new GridBagLayout());
    }

    public String open(Open open,String name){
	  setName(open.getParameter(name+"."));
	  return name+".";
    }

	public void removeSelected(){
		//remove from viewer
		selected.setSelect(false);
		remove(selected.getComponent());
	        validate();
	}

	public void register(FormInterfaceListener al){
		if ( (selected != null) && (selected !=al) ){
		   ((GridBagLayout)getLayout()).setConstraints(selected.getComponent(),((FormInterface)selected.getComponent()).getGridBagConstraints());
		   selected.getComponent().doLayout();
		   selected.setSelect(false);

	        }

		if (selected !=al){
		  selected = al;
		  selected.setSelect(true);
		}

	selected.getComponent().doLayout();
	doLayout();
      }	
		
      public Dimension getPreferredSized(){
                return new Dimension (500, 500);
        }

    public java.awt.Component add(FormInterface f){
	        Component added = null;
	        int index = 0;
		if (selected != null){
/*
		   if (current.getEndOfRow()){
			current.setEndOfRow(false);
			f.setEndOfRow(true);
		   }
*/
		   index = getIndex(current.getComponent()) ;
		   added = add((Component)f,index+1);
		} else {
		   added = add((Component)f);
		}

		//Component[] all = getComponents();
//for (int j = 0;j< all.length;j++){System.out.println("comp "+((FormInterface)all[j]).getName());}

	     //reFresh();
	     setCurrent(f);
	     //redo();
	     added.doLayout();
	     doLayout();
	     return added;
	}

    public java.awt.Component add(Component c){

	//adds the comp to the end with its specified constraints
      super.addImpl(c,((FormInterface)c).getGridBagConstraints(),-1);
      return c;
    }

    public void printComps(){

           for (int i =0; i < getComponentCount(); i++)
          System.out.println(getComponent(i).toString());
    }

    public void setFont(Font newFont){
        font = newFont;
        for (int i =0; i < getComponentCount(); i++)
          getComponent(i).setFont(font);
    }

	public int getIndex(Component c){
		Component[] all = getComponents();

		for (int i = 0; i < all.length; i++){
			if (all[i] == c)
				return i;
		}

		return -1;
	}

}
